// Capaleres *ix
#include <unistd.h>
#include <signal.h>
#include <stdlib.h>
#include <math.h>

#ifdef TIME_WITH_SYS_TIME 
# include <sys/time.h>
# include <time.h>
#else
# if HAVE_SYS_TIME_H
#  include <sys/time.h>
# else
#  include <time.h>
# endif
#endif

// Capaleres RTB
#include "Messagetypes.h"

// Capaleres STL
#include <iostream.h>
#include <string>
#include <sstream>

// CONFIGURACIONS
#define ROBOT_NOM   "CABRON"
#define ROBOT_COLOR "abeedd ee3050"
#define MARGE	    (M_PI/360.0)*30.0
#define GROS	    0.25
// FUNCIONS
void entrada_misatges(int cosa);
int  get_msg_num(string s);
void do_initialize(void);
void do_game_starts(void);
void do_radar( double dist, object_type tipus, double angl );
void do_info( double time, double speed, double angl );
void do_robot_info( double energy, bool team );
void do_energy( double en );
void apocalipsi( void );

// variables globales
bool seeking    = false;
struct s_robot {
   double seek_ini;
   double seek_fin;
   double speed;
   double energy;
   double angl_cano;
   double angl_robot;
   double angl_radar;
};
typedef struct s_robot robot;

robot  minimal = { 0,0,0,0,0,0 };

double angl_dest   = -100.0;
double dist_dest   = -100.0;
int    rafaga      = 0;
int    espera      = 0;
bool   first       = false;

int    MAX_RAFAGA  = 4; 
int    MAX_ESPERA  = 11;

// MAIN
int main(int argc, char * argv[]) {
   sigset_t usr1set;
   
   signal(SIGUSR1, entrada_misatges);
   sigemptyset(&usr1set);
   sigaddset(&usr1set, SIGUSR1);
   sigprocmask(SIG_UNBLOCK, &usr1set, NULL);
   
   // Inicialitzacions
   cout << "RobotOption " << (int)SIGNAL << " " << (int)SIGUSR1 << endl;
   cout << "RobotOption " << (int)SEND_SIGNAL << " " << 1 << endl;
   cout << "RobotOption " << (int)SEND_ROTATION_REACHED << " " << 1 << endl;
   // Nom
   // Coloret

   for(;;sleep(10)) {	  
   }
   return(EXIT_SUCCESS);
}


void entrada_misatges(int sig) {

   cin.clear();
   for(;!cin.eof();) {
	int           msg_num;
	stringstream  strm;
	string	      linea;
	string        tmp;
	
	linea.clear();
	if( !getline(cin,linea) || (cin.eof()) )
           break;
	strm << linea;	
	strm >> tmp;

	msg_num = get_msg_num( tmp );
	switch(msg_num) {
	   double       D1;
	   double       D2;
	   double       D3;
	   int          I1;
	   int          I2;
	   int          I3;
	      
	   case INITIALIZE:
	      strm >> I1;
	      if( I1 )
	         do_initialize();	
              break;
	   case GAME_OPTION:
	      break;
	      
	   case GAME_STARTS:
	      do_game_starts();
	      break;
	      
	   case RADAR:
	      strm >> D1;
	      strm >> I1;
	      strm >> D2;
	      do_radar( D1,(object_type)I1, D2 );
	      break;
	      
	   case INFO:
	      strm >> D1;
	      strm >> D2;
	      strm >> D3;
	      do_info( D1, D2, D3 );
	      break;
	      
	   case ROBOT_INFO:
	      strm >> D1;
	      strm >> I1;
	      do_robot_info( D1, (bool)I1 );
	      break;
	      
	   case ROTATION_REACHED:
	      strm >> I1;
	      if( I1 == 2 ) {
		 // cano
		 if(first) {
		     cout << "RotateAmount 2 0.4" <<  + 2*GROS/dist_dest << endl;
		     first = false;
		 }
		 cout << "Shoot 25.0" << endl;
	      }
	      break;

	   case ENERGY:
	      strm >> D1;
	      do_energy(D1);
	      break;
	     	 
	   default:
	      break;
	}
   }
   
   if( abs(angl_dest - minimal.angl_cano) < GROS && rafaga-- > 0) {
      cout << "Shoot 14.0" << endl;
      espera = MAX_ESPERA;
   }
   else if( !(--espera) ) {
      cout   << "Rotate 4 1.65" << endl;
   }      
   signal (sig, entrada_misatges);
   return;
}

int  get_msg_num(string s) {
   int i;
   
   for(i=0;message_to_robot[i].msg[0];i++) {
      if( !strcmp(message_to_robot[i].msg,s.c_str()) )
          return i;
   }
   return -1;
}

// al inici
// en principi no posar res ms x aqu
void do_initialize(void) {
   cout << "Name " << ROBOT_NOM << endl;
   cout << "Colour " << ROBOT_COLOR << endl;
}

// tb al inici
void do_game_starts(void) {
	
    // 4      == RADAR
    // 1.65   == velocitat
    cout   << "Rotate 4 2.0" << endl;
    minimal.speed  = 0.0;
    minimal.energy = 100.0;
     //cout << "Accelerate " << acceleration << endl;
}

// coses que trovem per el cam
#define MAXELEM 4
#define MEMORIA 12

void do_radar( double dist, object_type tipus, double angl ) {
   minimal.angl_radar = angl;
   switch( tipus ) {
   	case ROBOT:
	     angl_dest = angl - GROS;
	     dist_dest = dist;
	     first = true;	     
	     cout << "RotateTo 2 1.99 " << angl-2*GROS/dist << endl;
	     cout << "Sweep 4 0.6 " << angl - 2.5*GROS/(dist) << " " << angl + 2.8*GROS/(dist) << endl;
	     rafaga  = MAX_RAFAGA;
	     break;
	     
	case SHOT:
	case COOKIE:
	case MINE:
	     cout << "RotateTo 2 1.5 " << angl << endl;
	     break;
	case WALL:
	     break;
	case LAST_OBJECT_TYPE:
	     break;
   }
}

// aqu ens envien coses
void do_info( double time, double speed, double angl ) {
   if( time > 30 ) {
      apocalipsi();
   }
   minimal.angl_cano = angl;
   minimal.speed     = 0.0;
}

// informacions dels contraris
void do_robot_info( double energy, bool team ) {
   minimal.energy = 100.0;	
}

void do_energy( double energy ) {
   if( energy < 45 )
	apocalipsi();
}

double done=false;
void apocalipsi( void ) {
    if( !done ) {
	done = true;
	cout << "================================" << endl;
	cout << "Print    Baby!! it is time to dye!!" << endl;
	cout << "================================" << endl;

	MAX_RAFAGA = 22;
	MAX_ESPERA = 30;
	// dems ..
    }
}

